glibmm: Gio::TlsClientConnection Class Reference

glibmm 2.35.8

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Examples

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions | Protected Member Functions | Related Functions | List of all members
Gio::TlsClientConnection Class Reference

TlsClientConnection - TLS client-side connection. More...

`#include <giomm/tlsclientconnection.h>`

Inheritance diagram for Gio::TlsClientConnection:
[legend]

## Public Member Functions
virtual | ~TlsClientConnection ()
GTlsClientConnection* | gobj ()
| Provides access to the underlying C GObject. More...
const GTlsClientConnection* | gobj () const
| Provides access to the underlying C GObject. More...
void | set_server_identity (const Glib::RefPtr< SocketConnectable >& identity)
| Sets conn's expected server identity, which is used both to tell servers on virtual hosts which certificate to present, and also to let conn know what name to look for in the certificate when performing TLS_CERTIFICATE_BAD_IDENTITY validation, if enabled. More...
Glib::RefPtr< SocketConnectable > | get_server_identity ()
| Gets conn's expected server identity. More...
Glib::RefPtr< const SocketConnectable > | get_server_identity () const
| Gets conn's expected server identity. More...
void | set_validation_flags (TlsCertificateFlags flags)
| Sets conn's validation flags, to override the default set of checks performed when validating a server certificate. More...
TlsCertificateFlags | get_validation_flags () const
| Gets conn's validation flags. More...
void | set_use_ssl3 (bool use_ssl3)
| If use_ssl3 is `true`, this forces conn to use SSL 3.0 rather than trying to properly negotiate the right version of TLS or SSL to use. More...
bool | get_use_ssl3 () const
| Gets whether conn will use SSL 3.0 rather than the highest-supported version of TLS; see g_tls_client_connection_set_use_ssl3(). More...
Glib::PropertyProxy < Glib::RefPtr < SocketConnectable > > | property_server_identity ()
| GSocketConnectable identifying the server. More...
Glib::PropertyProxy_ReadOnly < Glib::RefPtr < SocketConnectable > > | property_server_identity () const
| GSocketConnectable identifying the server. More...
Glib::PropertyProxy< bool > | property_use_ssl3 ()
| Use SSL 3.0 rather than trying to use TLS 1.x. More...
Glib::PropertyProxy_ReadOnly < bool > | property_use_ssl3 () const
| Use SSL 3.0 rather than trying to use TLS 1.x. More...
Glib::PropertyProxy < TlsCertificateFlags > | property_validation_flags ()
| What certificate validation to perform. More...
Glib::PropertyProxy_ReadOnly < TlsCertificateFlags > | property_validation_flags () const
| What certificate validation to perform. More...
Public Member Functions inherited from Glib::Interface
| Interface (const Glib::Interface_Class& interface_class)
| Called by constructors of derived classes. More...
| Interface (GObject* castitem)
| Called by constructors of derived classes. More...
virtual | ~Interface ()
GObject* | gobj ()
const GObject* | gobj () const
Public Member Functions inherited from Glib::ObjectBase
void | set_property_value (const Glib::ustring& property_name, const Glib::ValueBase& value)
| You probably want to use a specific property_*() accessor method instead. More...
void | get_property_value (const Glib::ustring& property_name, Glib::ValueBase& value) const
| You probably want to use a specific property_*() accessor method instead. More...
template<class PropertyType >
void | set_property (const Glib::ustring& property_name, const PropertyType& value)
| You probably want to use a specific property_*() accessor method instead. More...
template<class PropertyType >
void | get_property (const Glib::ustring& property_name, PropertyType& value) const
| You probably want to use a specific property_*() accessor method instead. More...
void | connect_property_changed (const Glib::ustring& property_name, const sigc::slot< void >& slot)
| You can use the signal_changed() signal of the property proxy instead, but this is necessary when using the reduced API. More...
sigc::connection | connect_property_changed_with_return (const Glib::ustring& property_name, const sigc::slot< void >& slot)
| You can use the signal_changed() signal of the property proxy instead, but this is necessary when using the reduced API. More...
void | freeze_notify ()
| Increases the freeze count on object. More...
void | thaw_notify ()
| Reverts the effect of a previous call to freeze_notify(). More...
virtual void | reference () const
| Increment the reference count for this object. More...
virtual void | unreference () const
| Decrement the reference count for this object. More...
GObject* | gobj ()
| Provides access to the underlying C GObject. More...
const GObject* | gobj () const
| Provides access to the underlying C GObject. More...
GObject* | gobj_copy () const
| Give a ref-ed copy to someone. Use for direct struct access. More...

## Static Public Member Functions
static void | add_interface (GType gtype_implementer)
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...

## Protected Member Functions
| TlsClientConnection ()
| You should derive from this class to use it. More...

## Related Functions
(Note that these are not member functions.)
Glib::RefPtr < Gio::TlsClientConnection > | wrap (GTlsClientConnection* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...

## Detailed Description

TlsClientConnection - TLS client-side connection.

TlsClientConnection is the client-side subclass of TlsConnection, representing a client-side TLS connection.

Since glibmm 2.36:

## Constructor & Destructor Documentation

Gio::TlsClientConnection::TlsClientConnection | ( |  | ) |
| protected

You should derive from this class to use it.

virtual Gio::TlsClientConnection::~TlsClientConnection | ( |  | ) |
| virtual

## Member Function Documentation

static void Gio::TlsClientConnection::add_interface | ( | GType | gtype_implementer | ) |
| static

Glib::RefPtr<SocketConnectable> Gio::TlsClientConnection::get_server_identity | ( |  | ) |

Gets conn's expected server identity.

Since glibmm 2.28:

Returns
  A SocketConnectable describing the expected server identity, or `0` if the expected identity is not known.

Glib::RefPtr<const SocketConnectable> Gio::TlsClientConnection::get_server_identity | ( |  | ) | const

Gets conn's expected server identity.

Since glibmm 2.28:

Returns
  A SocketConnectable describing the expected server identity, or `0` if the expected identity is not known.

static GType Gio::TlsClientConnection::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

bool Gio::TlsClientConnection::get_use_ssl3 | ( |  | ) | const

Gets whether conn will use SSL 3.0 rather than the highest-supported version of TLS; see g_tls_client_connection_set_use_ssl3().

Since glibmm 2.28:

Returns
  Whether conn will use SSL 3.0.

TlsCertificateFlags Gio::TlsClientConnection::get_validation_flags | ( |  | ) | const

Gets conn's validation flags.

Since glibmm 2.28:

Returns
  The validation flags.

GTlsClientConnection* Gio::TlsClientConnection::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

const GTlsClientConnection* Gio::TlsClientConnection::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

Glib::PropertyProxy< Glib::RefPtr<SocketConnectable> > Gio::TlsClientConnection::property_server_identity | ( |  | ) |

GSocketConnectable identifying the server.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< Glib::RefPtr<SocketConnectable> > Gio::TlsClientConnection::property_server_identity | ( |  | ) | const

GSocketConnectable identifying the server.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy< bool > Gio::TlsClientConnection::property_use_ssl3 | ( |  | ) |

Use SSL 3.0 rather than trying to use TLS 1.x.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< bool > Gio::TlsClientConnection::property_use_ssl3 | ( |  | ) | const

Use SSL 3.0 rather than trying to use TLS 1.x.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy< TlsCertificateFlags > Gio::TlsClientConnection::property_validation_flags | ( |  | ) |

What certificate validation to perform.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< TlsCertificateFlags > Gio::TlsClientConnection::property_validation_flags | ( |  | ) | const

What certificate validation to perform.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

void Gio::TlsClientConnection::set_server_identity | ( | const Glib::RefPtr< SocketConnectable >& | identity | ) |

Sets conn's expected server identity, which is used both to tell servers on virtual hosts which certificate to present, and also to let conn know what name to look for in the certificate when performing TLS_CERTIFICATE_BAD_IDENTITY validation, if enabled.

Since glibmm 2.28:

Parameters

  identity | A SocketConnectable describing the expected server identity.

void Gio::TlsClientConnection::set_use_ssl3 | ( | bool | use_ssl3 | ) |

If use_ssl3 is `true`, this forces conn to use SSL 3.0 rather than trying to properly negotiate the right version of TLS or SSL to use.

This can be used when talking to servers that do not implement the fallbacks correctly and which will therefore fail to handshake with a "modern" TLS handshake attempt.

Since glibmm 2.28:

Parameters

  use_ssl3 | Whether to use SSL 3.0.

void Gio::TlsClientConnection::set_validation_flags | ( | TlsCertificateFlags | flags | ) |

Sets conn's validation flags, to override the default set of checks performed when validating a server certificate.

By default, TLS_CERTIFICATE_VALIDATE_ALL is used.

Since glibmm 2.28:

Parameters

  flags | The TlsCertificateFlags to use.

## Friends And Related Function Documentation

Glib::RefPtr< Gio::TlsClientConnection > wrap | ( | GTlsClientConnection * | object,
|  | bool | take_copy = `false`
| ) |  |
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.